=begin
= Algebra
  Version 0.49  (2001.07.25)

  Shin-ichiro HARA (sinara@blade.nagaokaut.ac.jp)

This is a library of one-variate or multi-variate polynomials.

== 1. Tutorial

 * ((<Exercise|URL:exercise.html>))

== 2. Class and Module

 * ((<Polynomial|URL:polynomial.html>))
 * ((<EuclidianRing|URL:euclidian-ring.html>))
 * ((<MPolynomial|URL:m-polynomial.html>))
 * ((<ResidueClassRing|URL:residue-class-ring.html>))
 * ((<LocalizedRing|URL:localized-ring.html>))
 * ((<MatrixAlgebra|URL:matrix-algebra.html>))
 * ((<AlgebraicParser|URL:algebraic-parser.html>))(evaluation of algebraic strings)

== 3. Other

 * ((<Conversions of polynomial classes|URL:polynomial-converter.html>))

== 4. Contents of package

=== One variate polynomial
  polynomial.rb            Class of one variate polynomial
  euclidian-ring.rb        Module of Euclidian domain
  polynomial-factor.rb     Factorization:
    polynomial-factor-int.rb   Integer version
    polynomial-factor-zp.rb    Zp version
    polynomial-factor-alg.rb   Algebraic number version

=== Multi variate polynomial
  m-polynomial.rb         Class of multi-variate polynomial
    m-index.rb            Class of indices of degrees
  groebner-basis.rb       Module of Groebner basis
  groebner-basis-coeff.rb Module of division by Groebner basis

=== Common part
  numeric-supplement.rb   Supplement of Numeric
  prime-gen.rb            Class of prime numbers
  polynomial-converter.rb Conversions between polynomial classes
  algebraic-parser.rb     Evaluation of strings
  algebra-system.rb       Common specification of algebras

=== General algebra
  localized-ring.rb       Quotient fields
  matrix-algebra.rb       Matrix
  residue-class-ring.rb   Residue class ring

=== Others
  array-supplement.rb    Supplement of Array
  doc/                   Manuals(RD, HTML, TXT)
  sample/                Sample Codes
  work/                  (working directory for the developer)

== 5. ToDo
<<< todo.rd

=end

